package net.novagamestudios.kaffeekasse.model.session

import kotlinx.serialization.Serializable
import net.novagamestudios.kaffeekasse.model.kaffeekasse.KnownItemGroup

/**
 * A device (i.e. a tablet) that is used to interact with the Kaffeekasse.
 *
 * @property name The name of the device
 * @property itemTypeId Represents the placement of the device
 */
@Serializable
data class Device(
    val name: String?,
    val itemTypeId: Int?
) : java.io.Serializable {
    val knownItemGroup by lazy { itemTypeId?.let { KnownItemGroup.byId[it] } }
}