package net.novagamestudios.kaffeekasse.ui.util

import androidx.compose.ui.Modifier
import androidx.compose.ui.autofill.AutofillNode
import androidx.compose.ui.autofill.AutofillType
import androidx.compose.ui.composed
import androidx.compose.ui.focus.onFocusChanged
import androidx.compose.ui.layout.boundsInWindow
import androidx.compose.ui.layout.onGloballyPositioned
import androidx.compose.ui.platform.LocalAutofill
import androidx.compose.ui.platform.LocalAutofillTree

fun Modifier.autofill(
    autofillTypes: List<AutofillType>,
    onFill: (String) -> Unit
) = composed {
    val autofill = LocalAutofill.current
    val autofillNode = AutofillNode(
        autofillTypes = autofillTypes,
        onFill = onFill
    )
    LocalAutofillTree.current += autofillNode
    this
        .onGloballyPositioned { autofillNode.boundingBox = it.boundsInWindow() }
        .onFocusChanged {
            autofill?.run {
                if (it.isFocused) requestAutofillForNode(autofillNode)
                else cancelAutofillForNode(autofillNode)
            }
        }
}